// xb4d_MTF

#property indicator_separate_window
#property indicator_minimum -1.5
#property indicator_maximum 1.5
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 OrangeRed
#property indicator_width1 2
#property indicator_width2 2

extern int period = 10;
extern string Label1 = "=== Timeframes To Display ===";
extern string Timeframes = "M1,M5,M15,M30,H1,H4,D1,W1,MN";
extern int Candles_per_TF = 28;
extern string Label2 = "=== Color Settings ===";
extern color BackgroundColor = White;//C'0x0F,0x0F,0x0F';
extern color BorderColor = DarkSlateGray;//C'0x46,0x46,0x46';
extern color TimeframeColor = DarkGray;
extern string Label3 = "=== Alerts Settings ===";
extern bool Alert_at_color_change = FALSE;
extern bool Alert_at_0_line_cross = FALSE;
extern bool Alert_at_Candle_Close = TRUE;
extern bool SoundAlert = FALSE;
extern bool PopUpAlert = FALSE;
extern bool SendAlertEmail = FALSE;
extern bool SendAlertPush = FALSE;
int Gi_152;
int Gia_156[10];
string Gs_160;
string Gsa_168[10];
double G_ibuf_172[];
double G_ibuf_176[];
double Gd_180;
double Gd_188;
double Gd_196;
double Gd_204;

int init() {
   IndicatorDigits(Digits + 1);
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(0, G_ibuf_172);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(1, G_ibuf_176);
   SetIndexLabel(0, "");
   SetIndexLabel(1, "");
   Gs_160 = "xb4d_MTF";
   IndicatorShortName(Gs_160);
   f0_2();
   if (ObjectFind("xb4d_alert_M1") != -1 && StringFind(Timeframes, "M1") == -1) ObjectDelete("xb4d_alert_M1");
   if (ObjectFind("xb4d_alert_M5") != -1 && StringFind(Timeframes, "M5") == -1) ObjectDelete("xb4d_alert_M5");
   if (ObjectFind("xb4d_alert_M15") != -1 && StringFind(Timeframes, "M15") == -1) ObjectDelete("xb4d_alert_M15");
   if (ObjectFind("xb4d_alert_M30") != -1 && StringFind(Timeframes, "M30") == -1) ObjectDelete("xb4d_alert_M30");
   if (ObjectFind("xb4d_alert_H1") != -1 && StringFind(Timeframes, "H1") == -1) ObjectDelete("xb4d_alert_H1");
   if (ObjectFind("xb4d_alert_H4") != -1 && StringFind(Timeframes, "H4") == -1) ObjectDelete("xb4d_alert_H4");
   if (ObjectFind("xb4d_alert_D1") != -1 && StringFind(Timeframes, "D1") == -1) ObjectDelete("xb4d_alert_D1");
   if (ObjectFind("xb4d_alert_W1") != -1 && StringFind(Timeframes, "W1") == -1) ObjectDelete("xb4d_alert_W1");
   if (ObjectFind("xb4d_alert_MN") != -1 && StringFind(Timeframes, "MN") == -1) ObjectDelete("xb4d_alert_MN");
   //f0_0();
   return (0);
}

int deinit() {
   string name_0;
   int objs_total_8 = ObjectsTotal();
   for (int Li_12 = objs_total_8 - 1; Li_12 >= 0; Li_12--) {
      name_0 = ObjectName(Li_12);
      if (StringFind(name_0, "xb4d_") != -1 && StringFind(name_0, "xb4d_alert_") == -1) ObjectDelete(name_0);
   }
   return (0);
}

int start() {
   RefreshRates();
   for (int Li_0 = 1000; Li_0 >= 0; Li_0--) {
      G_ibuf_172[Li_0] = EMPTY_VALUE;
      G_ibuf_176[Li_0] = EMPTY_VALUE;
   }
   int Li_4 = 0;
   for (int index_8 = 0; index_8 < Gi_152; index_8++) {
      if (Li_4 == 0) {
         f0_1("xb4d_rect_" + Gsa_168[index_8], "", OBJ_RECTANGLE, Time[Li_4] + 60 * (Period() * 2), 1.2, Time[Li_4 + Candles_per_TF + 2], -1.4, BackgroundColor,
            TRUE, "", 9);
      } else f0_1("xb4d_rect_" + Gsa_168[index_8], "", OBJ_RECTANGLE, Time[Li_4 - 2], 1.2, Time[Li_4 + Candles_per_TF + 2], -1.4, BackgroundColor, TRUE, "", 9);
      if (Li_4 == 0) {
         f0_1("xb4d_bord_" + Gsa_168[index_8], "", OBJ_RECTANGLE, Time[Li_4] + 60 * (Period() * 2), 1.2, Time[Li_4 + Candles_per_TF + 2], -1.4, BorderColor,
            FALSE, "", 9);
      } else f0_1("xb4d_bord_" + Gsa_168[index_8], "", OBJ_RECTANGLE, Time[Li_4 - 2], 1.2, Time[Li_4 + Candles_per_TF + 2], -1.4, BorderColor, FALSE, "", 9);
      f0_1("xb4d_tf_" + Gsa_168[index_8], Gsa_168[index_8], OBJ_TEXT, Time[Candles_per_TF - 2 + Li_4], -1.1, 0, 0, TimeframeColor, FALSE, "Arial Bold",
         9);
      if (SoundAlert || PopUpAlert || SendAlertEmail || SendAlertPush) {
         if (ObjectFind("xb4d_alert_" + Gsa_168[index_8]) != -1 && ObjectGet("xb4d_alert_" + Gsa_168[index_8], OBJPROP_PRICE1) != -1.1) {
            if (ObjectGet("xb4d_alert_" + Gsa_168[index_8], OBJPROP_COLOR) == 65280.0) {
               ObjectDelete("xb4d_alert_" + Gsa_168[index_8]);
               f0_1("xb4d_alert_" + Gsa_168[index_8], "A", OBJ_TEXT, Time[Li_4 + 1], -1.1, 0, 0, DimGray, FALSE, "MS Outlook", 8);
            } else {
               if (ObjectGet("xb4d_alert_" + Gsa_168[index_8], OBJPROP_COLOR) == 255.0) {
                  ObjectDelete("xb4d_alert_" + Gsa_168[index_8]);
                  f0_1("xb4d_alert_" + Gsa_168[index_8], "A", OBJ_TEXT, Time[Li_4 + 1], -1.1, 0, 0, Lime, FALSE, "MS Outlook", 8);
               }
            }
         }
      }
      if (ObjectGet("xb4d_alert_" + Gsa_168[index_8], OBJPROP_COLOR) == 65280.0) f0_1("xb4d_alert_" + Gsa_168[index_8], "A", OBJ_TEXT, Time[Li_4 + 1], -1.1, 0, 0, Lime, FALSE, "MS Outlook", 8);
      else f0_1("xb4d_alert_" + Gsa_168[index_8], "A", OBJ_TEXT, Time[Li_4 + 1], -1.1, 0, 0, DimGray, FALSE, "MS Outlook", 8);
      for (Li_0 = Candles_per_TF + Li_4; Li_0 >= Li_4; Li_0--) {
         f0_6(f0_3(Gsa_168[index_8]), Li_0 - Li_4);
         Gd_180 = f0_7(f0_3(Gsa_168[index_8]), Li_0 - Li_4);
         Gd_188 = f0_7(f0_3(Gsa_168[index_8]), Li_0 - Li_4 + 1);
         Gd_204 = MathMax(Gd_204, MathAbs(Gd_196));
         /*if (Gd_180 >= Gd_188) G_ibuf_172[Li_0] = Gd_180 / Gd_204;
         else G_ibuf_176[Li_0] = Gd_180 / Gd_204;*/
         if (Gd_180 >= 0) G_ibuf_172[Li_0] = Gd_180 / Gd_204;
         else G_ibuf_176[Li_0] = Gd_180 / Gd_204;
         if (ObjectGet("xb4d_alert_" + Gsa_168[index_8], OBJPROP_COLOR) == 65280.0 && Gia_156[index_8] != iTime(Symbol(), f0_3(Gsa_168[index_8]), 0)) {
            if (Li_0 == Li_4) {
               if (Alert_at_color_change) {
                  if (G_ibuf_176[Li_0 + Alert_at_Candle_Close] != EMPTY_VALUE && G_ibuf_176[Li_0 + Alert_at_Candle_Close + 1] == EMPTY_VALUE) {
                     f0_4("xb4d turned Down on " + Symbol() + " " + Gsa_168[index_8]);
                     Gia_156[index_8] = iTime(Symbol(), f0_3(Gsa_168[index_8]), 0);
                  } else {
                     if (G_ibuf_172[Li_0 + Alert_at_Candle_Close] != EMPTY_VALUE && G_ibuf_172[Li_0 + Alert_at_Candle_Close + 1] == EMPTY_VALUE) {
                        f0_4("xb4d turned Up on " + Symbol() + " " + Gsa_168[index_8]);
                        Gia_156[index_8] = iTime(Symbol(), f0_3(Gsa_168[index_8]), 0);
                     }
                  }
               }
               if (Alert_at_0_line_cross) {
                  if (
                  ((G_ibuf_176[Li_0 + Alert_at_Candle_Close] != EMPTY_VALUE && G_ibuf_176[Li_0 + Alert_at_Candle_Close] > 0.0) 
                  || (G_ibuf_172[Li_0 + Alert_at_Candle_Close] != EMPTY_VALUE && G_ibuf_172[Li_0 + Alert_at_Candle_Close] > 0.0))
                  && ((G_ibuf_176[Li_0 + Alert_at_Candle_Close + 1] != EMPTY_VALUE && G_ibuf_176[Li_0 + Alert_at_Candle_Close + 1] <= 0.0) 
                  || (G_ibuf_172[Li_0 + Alert_at_Candle_Close + 1] != EMPTY_VALUE && G_ibuf_172[Li_0 + Alert_at_Candle_Close + 1] <= 0.0))
                  ) {
                     f0_4("xb4d crossed Up 0 line on " + Symbol() + " " + Gsa_168[index_8]);
                     Gia_156[index_8] = iTime(Symbol(), f0_3(Gsa_168[index_8]), 0);
                     continue;
                  }
                  if (
                  ((G_ibuf_176[Li_0 + Alert_at_Candle_Close] != EMPTY_VALUE && G_ibuf_176[Li_0 + Alert_at_Candle_Close] < 0.0)
                  || (G_ibuf_172[Li_0 + Alert_at_Candle_Close] != EMPTY_VALUE && G_ibuf_172[Li_0 + Alert_at_Candle_Close] < 0.0) )
                  && ((G_ibuf_176[Li_0 + Alert_at_Candle_Close + 1] != EMPTY_VALUE && G_ibuf_176[Li_0 + Alert_at_Candle_Close + 1] >= 0.0)
                  || (G_ibuf_172[Li_0 + Alert_at_Candle_Close + 1] != EMPTY_VALUE && G_ibuf_172[Li_0 + Alert_at_Candle_Close + 1] >= 0.0))
                  ) {
                     f0_4("xb4d crossed Down 0 line on " + Symbol() + " " + Gsa_168[index_8]);
                     Gia_156[index_8] = iTime(Symbol(), f0_3(Gsa_168[index_8]), 0);
                  }
               }
            }
         }
      }
      Li_4 += Candles_per_TF + 5;
   }
   return (0);
}

double f0_7(int A_timeframe_0, int Ai_4) {
   return (iCustom(NULL,A_timeframe_0,"xb4d_2",period,0,Ai_4));
}

void f0_6(int A_timeframe_0, int Ai_unused_4) {
   double Ld_8;
   Gd_196 = 1000000000;
   Gd_204 = 0;
   for (int Li_16 = 0; Li_16 < Candles_per_TF + 1; Li_16++) {
      Ld_8 = iCustom(NULL,A_timeframe_0,"xb4d_2",period,0,Li_16);
      if (Ld_8 < Gd_196) Gd_196 = Ld_8;
      if (Ld_8 > Gd_204) Gd_204 = Ld_8;
   }
}

void f0_2() {
   int index_0 = 0;
   int Li_4 = 0;
   int Li_8 = 1;
   while (index_0 < 10 && Li_8 > 0) {
      Li_8 = StringFind(Timeframes, ",", Li_4);
      if (Li_8 == 0) Gsa_168[index_0] = StringSubstr(Timeframes, Li_4, 0);
      else Gsa_168[index_0] = StringSubstr(Timeframes, Li_4, Li_8 - Li_4);
      Gsa_168[index_0] = f0_8(Gsa_168[index_0]);
      index_0++;
      Li_4 = StringFind(Timeframes, ",", Li_4) + 1;
      if (Li_4 == 0) break;
   }
   Gi_152 = index_0;
}

string f0_8(string As_0) {
   As_0 = f0_5(As_0);
   if (As_0 == "1") return ("M1");
   if (As_0 == "5") return ("M5");
   if (As_0 == "15") return ("M15");
   if (As_0 == "30") return ("M30");
   if (As_0 == "60") return ("H1");
   if (As_0 == "240") return ("H4");
   if (As_0 == "1440") return ("D1");
   if (As_0 == "10080") return ("W1");
   if (As_0 == "43200") return ("MN");
   return (As_0);
}

int f0_3(string As_0) {
   int timeframe_8 = Period();
   if (As_0 == "M1" || As_0 == "1") timeframe_8 = 1;
   if (As_0 == "M5" || As_0 == "5") timeframe_8 = 5;
   if (As_0 == "M15" || As_0 == "15") timeframe_8 = 15;
   if (As_0 == "M30" || As_0 == "30") timeframe_8 = 30;
   if (As_0 == "H1" || As_0 == "60") timeframe_8 = 60;
   if (As_0 == "H4" || As_0 == "240") timeframe_8 = 240;
   if (As_0 == "D1" || As_0 == "1440") timeframe_8 = 1440;
   if (As_0 == "W1" || As_0 == "10080") timeframe_8 = 10080;
   if (As_0 == "MN" || As_0 == "43200") timeframe_8 = 43200;
   return (timeframe_8);
}

string f0_5(string As_0) {
   int Li_20;
   string Ls_ret_8 = As_0;
   for (int Li_16 = StringLen(As_0) - 1; Li_16 >= 0; Li_16--) {
      Li_20 = StringGetChar(Ls_ret_8, Li_16);
      if ((Li_20 > '`' && Li_20 < '{') || (Li_20 > '' && Li_20 < 256)) Ls_ret_8 = StringSetChar(Ls_ret_8, Li_16, Li_20 - 32);
      else
         if (Li_20 > -33 && Li_20 < 0) Ls_ret_8 = StringSetChar(Ls_ret_8, Li_16, Li_20 + 224);
   }
   return (Ls_ret_8);
}

void f0_1(string A_name_0, string A_text_8, int Ai_16, int A_datetime_20, double Ad_24, int A_datetime_32, double Ad_36, color A_color_44, int A_bool_48, string A_fontname_52, int A_fontsize_60) {
   if (ObjectFind(A_name_0) == -1) ObjectCreate(A_name_0, Ai_16, WindowFind(Gs_160), 0, 0, 0, 0);
   ObjectSet(A_name_0, OBJPROP_PRICE1, Ad_24);
   ObjectSet(A_name_0, OBJPROP_PRICE2, Ad_36);
   ObjectSet(A_name_0, OBJPROP_TIME1, A_datetime_20);
   ObjectSet(A_name_0, OBJPROP_TIME2, A_datetime_32);
   ObjectSet(A_name_0, OBJPROP_COLOR, A_color_44);
   ObjectSet(A_name_0, OBJPROP_WIDTH, 1);
   ObjectSet(A_name_0, OBJPROP_BACK, A_bool_48);
   ObjectSetText(A_name_0, A_text_8, A_fontsize_60, A_fontname_52, A_color_44);
}

void f0_4(string As_0) {
   if (SoundAlert) PlaySound("alert.wav");
   if (PopUpAlert) Alert("xb4d Alert - ", As_0, " at ", TimeToStr(TimeCurrent(), TIME_SECONDS));
   if (SendAlertEmail) SendMail("xb4d Alert", "xb4d Alert - " + As_0 + " at " + TimeToStr(TimeCurrent(), TIME_SECONDS) + " (server time)");
   if (SendAlertPush) SendNotification("xb4d Alert - " + As_0 + " at " + TimeToStr(TimeCurrent(), TIME_SECONDS) + " (server time)");
}
/*
void f0_0() {
   string name_0 = "xb4d";
   if (ObjectFind(name_0) == -1) ObjectCreate(name_0, OBJ_LABEL, 0, 0, 0);
   ObjectSet(name_0, OBJPROP_CORNER, 2);
   ObjectSet(name_0, OBJPROP_XDISTANCE, 3);
   ObjectSet(name_0, OBJPROP_YDISTANCE, 2);
   ObjectSetText(name_0, "xb4d_MTF", 8, "Verdana", C'0x3C,0x3C,0x3C');
}
*/